<?php
class ControllerAccountAvail extends Controller
{
    public function index()
    {
        if (!$this->customer->isLogged()) {
            $this->session->data['redirect'] = $this->url->link('account/avail', '', 'SSL');

            $this->response->redirect($this->url->link('account/login', '', 'SSL'));
        }

        $this->load->language('account/avail');

        $this->document->setTitle($this->language->get('heading_title'));


        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_account'),
            'href' => $this->url->link('account/avail', '', 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_newsletter'),
            'href' => $this->url->link('account/avail', '', 'SSL')
        );

        $data['heading_title'] = $this->language->get('heading_title');

        $data['button_continue'] = $this->language->get('button_continue');
        $data['button_back'] = $this->language->get('button_back');
        $data['text_data_add'] = $this->language->get('text_data_add');
        $data['text_product'] = $this->language->get('text_product');
        $data['text_quantity'] = $this->language->get('text_quantity');
        $data['text_yes'] = $this->language->get('text_yes');
        $data['text_no'] = $this->language->get('text_no');
        $data['text_delete'] = $this->language->get('text_delete');

        $data['action'] = $this->url->link('account/avail', '', 'SSL');
        $this->load->model('module/avail');

        $data['avails'] = $this->model_module_avail->getAvailabilities($this->customer->getId());


        $data['back'] = $this->url->link('account/account', '', 'SSL');

        $data['column_left'] = $this->load->controller('common/column_left');
        $data['column_right'] = $this->load->controller('common/column_right');
        $data['content_top'] = $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] = $this->load->controller('common/footer');
        $data['header'] = $this->load->controller('common/header');
        
        if(version_compare(VERSION, '2.2.0.0', '<') == true) {
            if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/account/avail.tpl')) {
                $this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/account/avail.tpl', $data));
            } else {
                $this->response->setOutput($this->load->view('default/template/account/avail.tpl', $data));
            }
        }else {
            return $this->response->setOutput($this->load->view('account/avail', $data));
        }
    }
    public function delete(){
        if (!$this->customer->isLogged()) {
            $this->session->data['redirect'] = $this->url->link('account/avail', '', 'SSL');

            $this->response->redirect($this->url->link('account/login', '', 'SSL'));
        }

        $this->load->language('account/avail');

        $this->document->setTitle($this->language->get('heading_title'));


        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_account'),
            'href' => $this->url->link('account/avail', '', 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_newsletter'),
            'href' => $this->url->link('account/avail', '', 'SSL')
        );

        $data['heading_title'] = $this->language->get('heading_title');

        $data['button_continue'] = $this->language->get('button_continue');
        $data['button_back'] = $this->language->get('button_back');
        $data['text_data_add'] = $this->language->get('text_data_add');
        $data['text_product'] = $this->language->get('text_product');
        $data['text_quantity'] = $this->language->get('text_quantity');
        $data['text_yes'] = $this->language->get('text_yes');
        $data['text_no'] = $this->language->get('text_no');
        $data['text_delete'] = $this->language->get('text_delete');

        $data['action'] = $this->url->link('account/avail', '', 'SSL');
        $this->load->model('module/avail');


        $data['back'] = $this->url->link('account/account', '', 'SSL');

        $data['column_left'] = $this->load->controller('common/column_left');
        $data['column_right'] = $this->load->controller('common/column_right');
        $data['content_top'] = $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] = $this->load->controller('common/footer');
        $data['header'] = $this->load->controller('common/header');
      

        if($this->model_module_avail->changeAvailStatus($this->request->get['avail_id'],'1')){
            $data['success'] =     $this->language->get('text_success');
        } else {
            $data['success'] =     $this->language->get('text_success_not');
        }

        $this->response->redirect($this->url->link('account/avail', '', 'SSL'));


    }
}